<?php

declare(strict_types=1);

namespace mirzaev\marina\controllers\traits;

/**
 * Заготовки для конвертации строк
 *
 * @package mirzaev\marina\controllers\traits
 * @author Arsen Mirzaev Tatyano-Muradovich <arsen@mirzaev.sexy>
 */
trait converters
{
	private static function utf8_to_extended_ascii(string $target, &$map)
	{
		// find all multibyte characters (cf. utf-8 encoding specs)
		$matches = array();
		if (!preg_match_all('/[\xC0-\xF7][\x80-\xBF]+/', $target, $matches))
			return $target; // plain ascii string

		// update the encoding map with the characters not already met
		foreach ($matches[0] as $mbc)
			if (!isset($map[$mbc]))
				$map[$mbc] = chr(128 + count($map));

		// finally remap non-ascii characters
		return strtr($target, $map);
	}
}
